/*****************************************************************************
**  Copyright (C) 2004                                                      **
**  University of Tennessee                                                 **
**                                                                          **
**  See the file COPYRIGHT in the package base directory for details        **
*****************************************************************************/

#include "Cnode.h"


#include "Callsite.h"

#include <vector>
using std::vector ; 

Cnode::Cnode(int id , Callsite* csite_ptr , Cnode* parent) :
  id(id),  csite_ptr(csite_ptr), parent(parent)                  
{
  if ( parent != NULL) 
    parent->add_child(this) ; 
}

Cnode::~Cnode()
{
  for(int i = 0 ; i < childv.size() ; i++)
    delete childv[i] ; 
}

ostream& operator<<(ostream& out, const Cnode& cnode)
{
  out << "CNODE" << " "
      <<  cnode.get_id() << " "
      <<  cnode.get_csite_ptr_id() << " "
      <<  cnode.get_parent_id()  << " "  
      <<  cnode.get_num_cnodes()<< " " ;

   for ( int i = 0; i < cnode.get_childv_size() ; i++ )
     out << cnode.get_child_id(i)<< " " ;

   out << endl ;
  return out;
}



