/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "Function.h"

#include "Callsite.h"
#include "Module.h"

bool
Function::is_mpi_init()
{
  if ( this->name.compare(0, 8, "MPI_INIT") == 0 || this->name.compare(0, 8,
"mpi_init") == 0 || this->name.compare(0, 8,"MPI_Init") == 0 )
    return true;
  else
    return false;
}


bool
Function::is_mpi_finalize()
{
  if ( this->name.compare(0, 12,"MPI_FINALIZE") == 0 || 
       this->name.compare(0,12, "mpi_finalize") == 0 || 
       this->name.compare(0, 12,"MPI_Finalize") == 0  )
    return true;
  else
    return false;
}

bool
Function::is_mpi()
{
  if ( this->name.compare(0, 3,"MPI") == 0 || 
       this->name.compare(0,3, "mpi") == 0   )
    return true;
  else
    return false;
}



ostream& operator<<(ostream& out, const Function& func)
{
  out << "FUNCTION" << " "
      << func.id << " " 
      << func.name << " "
      << func.begln << " "
      << func.endln << " "
      << func.mod->id << " "
      << func.csitev.size();
  
  for (int i = 0; i < func.csitev.size(); i++)
    out << " " << func.csitev[i]->id;

  out << endl;

  return out;
}
