/*****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _FUNCTION_H
#define _FUNCTION_H   

/*
 *----------------------------------------------------------------------------
 *
 * srtuctF Function
 *
 *----------------------------------------------------------------------------
 */

#include <iostream>
  using std::ostream;
  using std::endl;

#include <string>
  using std::string;

#include <vector>
  using std::vector;

#include <dpcl.h>

struct Callsite;
struct Module;

struct Function
{ 

  bool is_mpi_init();
  bool is_mpi_finalize();
  bool is_mpi();
  
  long               id;
  string             name;
  long               begln;
  long               endln;
  Module*            mod;
  vector<Callsite*>  csitev;
  InstPoint          entry;
  InstPoint          exit;
  bool               isuser;
  bool               isleaf;
};

ostream& operator<<(ostream& out, const Function& mod); 

#endif
