/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _CONE_CSITE_H
#define _CONE_CSITE_H

#include <stdio.h>

struct cone_csite;

struct cone_csite* cone_csite_create(char* csite_spec);
void               cone_csite_delete(struct cone_csite* csite);

long               cone_csite_id(struct cone_csite* csite);
long               cone_csite_index(struct cone_csite* csite);
long               cone_csite_mod_id(struct cone_csite* csite);
long               cone_csite_line(struct cone_csite* csite);
long               cone_csite_caller_id(struct cone_csite* csite);
long               cone_csite_callee_id(struct cone_csite* csite);
long               cone_csite_num_cnodes(struct cone_csite* csite);
long               cone_csite_cnode_id(struct cone_csite* csite, long i);

long               cone_csite_get_tag(struct cone_csite* csite);
void               cone_csite_set_tag(struct cone_csite* csite, long tag);

void               cone_csite_fprintf(FILE* stream, struct cone_csite* csite);

#endif
