/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#ifndef _CONE_ERROR_H
#define _CONE_ERROR_H

#ifdef __cplusplus
#   define EXTERN extern "C" 
#else
#   define EXTERN extern 
#endif

/*
 *-----------------------------------------------------------------------------
 *
 *  - Error messages
 * 
 *-----------------------------------------------------------------------------
 */

#include <stdarg.h>

/* abort and system error message */
EXTERN void cone_error();                          

/* abort and user error message */
EXTERN void cone_error_msg(const char* fmt, ...);

/* user warning message without abort */
EXTERN void cone_warning(const char* fmt, ...);

/* user control message without abort (printed only if CONE_VERBOSE is set) */
EXTERN void cone_cntl_msg(const char* fmt, ...);

#endif






