/****************************************************************************
**  Copyright (C) 2004                                                     **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _CONE_METV_H
#define _CONE_METV_H

#ifdef __cplusplus
#   define EXTERN extern "C" 
#else
#   define EXTERN extern 
#endif


/* maximum number of events */
#define CONE_METV_MAXSIZE 12

struct cone_metv;
struct cone_metric;

EXTERN int                 cone_metv_open();                           /* returns number of counters */ 
EXTERN void                cone_metv_close();
EXTERN void                cone_metv_thread_init(int (*id_fn)(void));  /* supply omp_get_thread_num() as argument */

EXTERN int                 cone_metv_size();                           /* returns number of counters */ 
EXTERN double              cone_metv_clckrt();                         /* returns clock rate in Hz */ 

/* for i provide a value between 0 and cone_metv_num() - 1 */

EXTERN struct cone_metric* cone_metv_metric(int i);

/* create and free per-thread counter sets */

EXTERN struct cone_metv*   cone_metv_create();
EXTERN void                cone_metv_free(struct cone_metv* metv);

/* reads values of counters relative to the time of cone_metv_init() */
EXTERN void                cone_metv_read(struct cone_metv* metv, unsigned long long values[]);

#endif









