# Sample batch script for a mpi job
#
# Submit this script using the "llsubmit" command: llsubmit mpi.ll
#
# Use the "llq" command to check the status of a job.
#
# Lines starting with #@ are embedded loadleveler directives.
# To comment out a loadleveler directive, put # in front of #@ 

#@ shell = /usr/bin/bash
#@ job_type = parallel

# copy all environment variables to batch job
#@ environment = COPY_ALL

# Send email when job completes
# (notification options: always,start,error,complete,never)
#@ notification = always

# Specify job class
#@ class = batch

# Charge job to project abc (recommended for users with multiple projects)
# [If project is invalid, a valid project will be automatically selected]
##@ account_no = abc

# Specify number of MPI processes
#@ tasks_per_node = 2

# Specify memory = amount per MPI process
# For mpi, ConsumableCpus is always 1, and it must be specified.
#@ resources = ConsumableCpus(1) ConsumableMemory(100Mb)

# Specify the wall clock limit = hrs:min:sec
#@ wall_clock_limit = 00:00:40

# Specify the name of the job
#@ job_name = mpi_hello

# Specify the standard output and standard error for the job
# They will be written in the subdirectory from which llsubmit is run
#@ output = $(job_name).out
#@ error = $(job_name).err

##@ requirements = (Machine == "cu12")

# This has to be the last loadleveler directive
#@ queue
##########################################################

export PATH=${PATH}:/u/ac/nikhil/bin

# run mpi executable 
poe /u/ac/nikhil/pipe/cone/src/test/mpi_hello_d &
echo "POE_process:  $!" >> poe_id
ps -fu nikhil | grep poe >> ps_out
wait $!
